## Copyright (c) 2012 Miguel Bazdresch
##
## Permission is hereby granted, free of charge, to any person obtaining a
## copy of this software and associated documentation files (the "Software"),
## to deal in the Software without restriction, including without limitation
## the rights to use, copy, modify, merge, publish, distribute, sublicense,
## and/or sell copies of the Software, and to permit persons to whom the
## Software is furnished to do so, subject to the following conditions:
##
## The above copyright notice and this permission notice shall be included in
## all copies or substantial portions of the Software.
##
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
## FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
## DEALINGS IN THE SOFTWARE.

# gtk-server interface for Julia

function gtk_init()

    # start gtk-server
    fifo = "/tmp/julia.gtk.$(randstring(5))"
    system("gtk-server -fifo=$fifo &")

    # wait for gtk-server to create fifo
    sleep(0.2)
    return fifo

end

function gtk_send(f,s::ASCIIString)
    fw = open(f,"w")
    write(fw,s)
    close(fw)
    fr = open(f,"r")
    r = readchomp(fr)
    close(fr)
    return r
end

function gtk_exit(f)
    gtk_send(f,"gtk_server_exit")
end
